/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 INRIA
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Rao Naveed Bin Rais <Naveed-Bin.Rais@inria.fr>
 */
 
#include "medeha-intra-manet-notif-header.h"
#include "ns3/address-utils.h"
#include "ns3/log.h"
#include "ns3/simulator.h"

//#define   DEBUG

NS_LOG_COMPONENT_DEFINE ("MedehaIntraManetNotifHeader");

namespace ns3 {

MedehaIntraManetNotifHeader::MedehaIntraManetNotifHeader ()
  : m_type (0),
    m_protocol (0)
{}

MedehaIntraManetNotifHeader::~MedehaIntraManetNotifHeader ()
{}

TypeId 
MedehaIntraManetNotifHeader::GetTypeId (void)
{
  static TypeId tid = TypeId ("ns3::MedehaIntraManetNotifHeader")
    .SetParent<Header> ()
    .AddConstructor<MedehaIntraManetNotifHeader> ()
    ;
  return tid;
}

TypeId 
MedehaIntraManetNotifHeader::GetInstanceTypeId (void) const
{
  return GetTypeId ();
}

void 
MedehaIntraManetNotifHeader::Print (std::ostream &os) const
{
 
}

uint32_t 
MedehaIntraManetNotifHeader::GetSerializedSize (void) const
{
  return 8;
//  return GetSize ();
}

void 
MedehaIntraManetNotifHeader::Serialize (Buffer::Iterator i) const
{
  i.WriteU16 (m_type);
  i.WriteU16 (m_protocol);

  WriteTo (i, m_dstIPAddress);
}

uint32_t
MedehaIntraManetNotifHeader::Deserialize (Buffer::Iterator start)
{
  Buffer::Iterator i = start;
  m_msgtype = i.ReadU16 ();

  m_protocol = i.ReadU16 ();
  ReadFrom (i, m_dstIPAddress);
  
  return i.GetDistanceFrom (start);
}

} // ns3 namespace
